<?php
//OPTIONS
define('RPX_API_KEY_OPTION',               'rpx_api_key_option');
define('RPX_REALM_OPTION',                 'rpx_realm_option');
define('RPX_REALM_SCHEME',                 'rpx_realm_scheme');
define('RPX_APP_ID_OPTION',                'rpx_app_id_option');
define('RPX_ADMIN_URL_OPTION',             'rpx_admin_url_option');
define('RPX_VEMAIL_OPTION',                'rpx_vemail_option');
define('RPX_VEMAIL_OPTION_DEFAULT',        true);
define('RPX_SOCIAL_OPTION',                'rpx_social_option');
define('RPX_SOCIAL_OPTION_DEFAULT',        false);
define('RPX_SOCIAL_COMMENT_OPTION',        'rpx_social_comment_option');
define('RPX_SOCIAL_COMMENT_OPTION_DEFAULT',false);
define('RPX_SOCIAL_PUB',                   'rpx_social_pub');
define('RPX_S_LOC_OPTION',                 'rpx_s_loc_option');
define('RPX_S_LOC_OPTION_DEFAULT',         'top');
define('RPX_COMMENT_OPTION',               'rpx_comment_login_action');
define('RPX_COMMENT_OPTION_DEFAULT',       '');
define('RPX_HTTP_OPTION',                  'rpx_http_option');
define('RPX_HTTP_OPTION_DEFAULT',          'wp_http');
define('RPX_SSL_VALID_OPTION',             'rpx_ssl_valid_option');
define('RPX_SSL_VALID_OPTION_DEFAULT',     true);
define('RPX_AUTOREG_OPTION',               'rpx_autoreg_option');
define('RPX_AUTOREG_OPTION_DEFAULT',       true);
define('RPX_PROVIDERS_OPTION',             'rpx_providers_option');
define('RPX_NONCE',                        'rpx_nonce');
define('RPX_CSRF_TOKEN',                   'rpx_csrf_token');
define('RPX_SERVER',                       'rpxnow.com');
define('RPX_API_PATH',                     '/api/v2/');
define('RPX_IMAGE_PATH',                   '/rpx/images/');
define('RPX_FILES_PATH',                   '/rpx/files/');
define('RPX_MENU_SLUG',                    'JUMP');
define('RPX_MENU_PARENT',                  'options-general.php');
define('RPX_OPTIONS_TITLE',                'Janrain Engage Options');
define('RPX_MENU_LABEL',                   'Janrain Engage');
define('RPX_OPTIONS_ROLE',                 'administrator');
define('RPX_TOKEN_ACTION',                 'rpx_token');
define('RPX_TOKEN_ACTION_NAME',            'rpx_token');
define('RPX_REGISTER_FORM_ACTION',         'rpx_register');
define('RPX_REGISTER_FORM_ACTION_NAME',    'rpx_register');
define('RPX_TOKEN_URL',                    str_replace('./','/',get_option('siteurl')) . '/?action='.RPX_TOKEN_ACTION);//Strip trailing dot. (dot terminated FQDN is currently unsupported)
define('RPX_META_IDENTIFIER',              'rpx_identifier');
define('RPX_META_PROVIDER',                'rpx_provider');
define('RPX_META_LOCKED',                  'rpx_locked');
define('RPX_META_SESSION',                 'rpx_session');
define('RPX_META_URL',                     'rpx_url');
define('RPX_META_PROFILE',                 'rpx_serial_profile');
define('RPX_META_CONTACTS',                'rpx_serial_contacts');
define('RPX_COMMENT_PROMPT_OPTION',        'rpx_comment_prompt_option');
define('RPX_SIGNIN_SETUP_URL',             '/setup_providers#steps');
define('RPX_SOCIAL_SETUP_URL',             '/social_publishing_2#steps');
define('RPX_SETTINGS_SETUP_URL',           '/settings');
define('RPX_IS_WPMU',                      WP_ALLOW_MULTISITE);
define('RPX_BP_REG_PATH',                  'register');
define('RPX_WP_REG_PATH',                  'wp-login.php?action=register');

//PROFILE MAP
$rpx_profile_map = array();
$rpx_profile_map['identifier']         ='rpx_identifier';
$rpx_profile_map['providerName']       ='rpx_provider';
$rpx_profile_map['email']              ='rpx_email';
$rpx_profile_map['verifiedEmail']      ='rpx_verifiedEmail';
$rpx_profile_map['preferredUsername']  ='rpx_username';
$rpx_profile_map['displayName']        ='rpx_displayname';
$rpx_profile_map['name']['givenName']  ='rpx_given';
$rpx_profile_map['name']['familyName'] ='rpx_family';
$rpx_profile_map['name']['formatted']  ='rpx_realname';
$rpx_profile_map['photo']              ='rpx_photo';
$rpx_profile_map['url']                ='rpx_url';
$rpx_profile_map['gender']             ='rpx_gender';
$rpx_profile_map['birthday']           ='rpx_birthday';
$rpx_profile_map['utcOffset']          ='rpx_utcOffset';

$rpx_wp_user_map = array();
$rpx_wp_user_map['rpx_username']    = 'user_login';
$rpx_wp_user_map['rpx_url']         = 'user_url';
$rpx_wp_user_map['rpx_email']       = 'user_email';
$rpx_wp_user_map['rpx_displayname'] = 'display_name';
$rpx_wp_user_map['rpx_given']       = 'first_name';
$rpx_wp_user_map['rpx_family']      = 'last_name';

//MESSAGE MAP
$rpx_message_map['stat']        ='rpx_stat';
$rpx_message_map['limitedData'] ='rpx_limited';
$rpx_message_map['err']['msg']  ='rpx_error';
$rpx_message_map['err']['code'] ='rpx_code';

//PROVIDER LIST
$rpx_providers = array();
$rpx_providers['Facebook']     = 'facebook';
$rpx_providers['Google']       = 'google';
$rpx_providers['GoogleApps']   = 'google';
$rpx_providers['LinkedIn']     = 'linkedin';
$rpx_providers['MySpace']      = 'myspace';
$rpx_providers['Twitter']      = 'twitter';
$rpx_providers['Windows Live'] = 'live_id';
$rpx_providers['Yahoo!']       = 'yahoo';
$rpx_providers['AOL']          = 'aol';
$rpx_providers['Blogger']      = 'blogger';
$rpx_providers['Flickr']       = 'flickr';
$rpx_providers['Hyves']        = 'hyves';
$rpx_providers['LiveJournal']  = 'livejournal';
$rpx_providers['MyOpenID']     = 'myopenid';
$rpx_providers['Netlog']       = 'netlog';
$rpx_providers['OpenID']       = 'openid';
$rpx_providers['Verisign']     = 'verisign';
$rpx_providers['Wordpress']    = 'wordpress';
$rpx_providers['PayPal']       = 'paypal';

//HTTP VARS
$rpx_http_vars = array();
$rpx_http_vars['rpx_identifier'] ='';
$rpx_http_vars['rpx_provider']   ='';
$rpx_http_vars['rpx_username']   ='';
$rpx_http_vars['rpx_email']      ='';
$rpx_http_vars['rpx_redirect']   ='';
$rpx_http_vars['rpx_error']      ='';
$rpx_http_vars['rpx_message']    ='';
$rpx_http_vars['rpx_install']    ='';
$rpx_http_vars['rpx_remove']     ='';
$rpx_http_vars['rpx_config']     ='';
$rpx_http_vars['rpx_attach']     ='';
$rpx_http_vars['rpx_update']     ='';
$rpx_http_vars['rpx_session']    ='';
$rpx_http_vars['action']         ='';
$rpx_http_vars['token']          ='';
$rpx_http_vars['user_email']     ='';
$rpx_http_vars['user_name']      ='';
$rpx_http_vars['redirect_to']    ='';
$rpx_http_vars['rpx_cleanup']    ='';
$rpx_http_vars['rpx_collect']    ='';
$rpx_http_vars['rpx_icons']      ='';

foreach ($rpx_http_vars as $parm => $value){
  $rpx_parm = urldecode(strip_tags($_REQUEST[$parm]));
  if ( !empty($rpx_parm) ){
    $rpx_http_vars[$parm] = $rpx_parm;
  }
}

if ( empty($rpx_http_vars['redirect_to']) ){
    if ( !empty($redirect_to) ){
      $redirect_to = $rpx_http_vars['redirect_to'];
    }
}


//COMMENT FORM LOGIN ACTIONS
$rpx_comment_actions = array();
$rpx_comment_actions['comment_form_before *']                 = 'comment_form_before';
$rpx_comment_actions['comment_form_top *']                    = 'comment_form_top';
$rpx_comment_actions['comment_form']                          = 'comment_form';
$rpx_comment_actions['comment_form_before_fields *']          = 'comment_form_before_fields';
$rpx_comment_actions['comment_form_after *']                  = 'comment_form_after';
$rpx_comment_actions['comment_form_must_log_in_after &sup1;'] = 'comment_form_must_log_in_after';


$rpx_csrf    = strip_tags($_REQUEST[RPX_CSRF_TOKEN]);
$rpx_api_key = strip_tags($_REQUEST[RPX_API_KEY_OPTION]);

$rpx_messages   = array();
$rpx_wp_profile = array();
$rpx_wp_user    = array();

$rpx_button_count = 0;

?>
