<?php

function rpx_js_escape($string){
  if ( empty($string) ){
    $string = ' ';
  }
  $string = strip_tags($string);
  $string = str_replace("\0",' ',$string);
  $string = str_replace("\n",' ',$string);
  $string = str_replace("\r",' ',$string);
  $string = str_replace('  ', ' ', $string);
  $string = strip_shortcodes($string);
  return addcslashes($string,"\\\'\"&\n\r<>");
}

function rpx_inline_stylesheet(){
?>
<style type="text/css">
/* Janrain Engage plugin dynamic CSS elements */
.rpxsocial {
<?php
  if (RPX_SHOW_JLOGO_SHARE === true){ 
?>
  padding:4px 4px 2px 24px;
  background-image:url('<?php echo WP_PLUGIN_URL.RPX_IMAGE_PATH; ?>janrain_icon_small.png');
<?php
  }else{
?>
  padding:4px 4px 2px 6px;
<?php
  }
?>
}

.rpx_icon_small,
.rpx_social_icons .rpx_icon_small {
  background-image:url('<?php echo WP_PLUGIN_URL.RPX_IMAGE_PATH; ?>providers_icons16.png');
}

.rpx_icon_large,
.rpx_large_icons .rpx_icon_large {
  background-image:url('<?php echo WP_PLUGIN_URL.RPX_IMAGE_PATH; ?>providers_icons32.png');
}
</style>
<?php
}

function rpx_inline_javascript(){
  $rpx_social_option = get_option(RPX_SOCIAL_OPTION);	
  $rpx_social_pub = get_option(RPX_SOCIAL_PUB);
  if ($rpx_social_option == 'true' && !empty($rpx_social_pub) ){
?>
<script type="text/javascript"><!--
function rpxWPsocial (rpxLabel, rpxSummary, rpxLink, rpxLinkText, rpxComment){
  RPXNOW.init({appId: '<?php echo get_option(RPX_APP_ID_OPTION); ?>', xdReceiver: '<?php echo WP_PLUGIN_URL; ?>/rpx/rpx_xdcomm.html'});
  RPXNOW.loadAndRun(['Social'], function () {
    var activity = new RPXNOW.Social.Activity(
       rpxLabel,
       rpxLinkText,
       rpxLink);
    activity.setUserGeneratedContent(rpxComment);
    activity.setDescription(rpxSummary);
    RPXNOW.Social.publishActivity(activity);
  });
}
--></script>
<?php
  }
}


function rpx_print_messages(){
  global $rpx_messages;
  $output = '';
  $id = 0;
  foreach ($rpx_messages as $key => $message_array){
    if ( empty($message_array['message']) ){
      $message_array['message'] = 'Empty message.';
    }
    if ( empty($message_array['class']) ){
      $message_array['class'] = 'message';
    }
    if ($message_array['class'] != 'html'){
      $message_array['class'] = htmlentities($message_array['class']);
      $message_array['message'] = nl2br(htmlentities($message_array['message']));
    }else{
      $message_array['class'] = 'message updated';
    }
    $id++;
    $output .= '<p id="rpx_message_'.$id.'" class="'.$message_array['class'].'">'.RPX_MESSAGE_PRE.$message_array['message'].'</p>';
  }
  if ( !empty($output) ){
    echo '<div id="rpxmessage" class="message">'.$output.'</div>';
  }
}

function rpx_admin_menu_view(){
  global $rpx_comment_actions;
  global $rpx_http_vars;

  if ($rpx_http_vars['rpx_cleanup'] == 'true'){
    rpx_clean_locked();
  }

  $rpx_apikey = get_option(RPX_API_KEY_OPTION);
  if ($rpx_http_vars['rpx_icons'] == 'true'){
    if (!rpx_update_icons($rpx_apikey)){
      rpx_message('icon update failed','debug');
    }
  }
  if (strlen($rpx_apikey) != 40){
    rpx_message ('<strong>Enter valid API key.</strong><br />'
                .'Get your apiKey '
                 .'<a target="new" href="https://login.janrain.com/openid/v2/signin?token_url=https%3A%2F%2Frpxnow.com%2Ffinish">here</a>'
                 .' if you have an Engage account.<br />'
                .'View the account options '
                 .'<a target="new" href="http://www.janrain.com/products/engage/get-janrain-engage">here</a>'
                 .' to become a Janrain Engage customer.', 'html');
  }
  $rpx_test = rpx_test_api();
  $messages = array();
  $messages['select'] = 'No supported HTTP option.';
  $messages['post'] = 'Unable to send POST to Engage server.';
  $messages['api']  = 'Unable to retrive data from Engage API.';
  $messages['ssl_valid'] = 'This PHP does not support SSL certificate validation, certificate testing disabled.';
  foreach ($messages as $key=>$message){
    if ($rpx_test[$key] === false){
      rpx_message ($message, 'error');
    }
  }
?>
<style type="text/css">
.rpx_tr_sub td {
  padding-left:40px;
}
.rpx_tr_lt {
  background-color:#EEE;
}
.rpx_tr_dk {
  background-color:#DDD;
}
.rpx_td_left {
  text-align:left;
}
.rpx_note {
  float:left;
}
</style>
<script type="text/javascript">
function rpxshowhide(box,val) {
  if(document.getElementById(box).checked==true) {
    document.getElementById(val).style.visibility="visible";
  } else {
    document.getElementById(val).style.visibility="hidden";
  }
} 
</script>
<div class="wrap">
<h2>Janrain Engage</h2>
<?php rpx_print_messages(); ?>
<form method="post" action="options.php">
  <?php settings_fields( 'rpx_settings_group' ); ?>
  <table class="form-table">
    <tr class="rpx_tr_dk">
      <td class="rpx_td">
      <label for="rpxapikey">Engage API Key: </label>
      <input id="rpxapikey" type="text" name="<?php echo RPX_API_KEY_OPTION; ?>" style="width:40em;" value="<?php echo get_option(RPX_API_KEY_OPTION); ?>" />
      </td>
      <td class="rpx_td">&nbsp;</td>
    </tr><?php
  if (strlen(get_option(RPX_API_KEY_OPTION)) == 40){?>
    <tr class="rpx_tr_lt">
      <td class="rpx_td">
      <h3>Sign-In Settings</h3>
      Setup Sign-In widget <a target="_blank" href="<?php echo get_option(RPX_ADMIN_URL_OPTION); echo RPX_SIGNIN_SETUP_URL; ?>">here</a>.<br />
      Add your site domain to the list <a target="_blank" href="<?php echo get_option(RPX_ADMIN_URL_OPTION); echo RPX_SETTINGS_SETUP_URL; ?>">here</a>.<br />
      Click <a href="?page=<?php echo RPX_MENU_SLUG; ?>&amp;rpx_icons=true">here</a> to update Engage provider icons.<?php echo rpx_small_buttons(); ?>
      </td>
      <td class="rpx_td">&nbsp;</td>
    </tr>
    <tr class="rpx_tr_lt rpx_tr_sub">
      <td class="rpx_td">
      <label for="rpxvemail">Allow sign in based on verifiedEmail match:</label>
      <input id="rpxvemail" type="checkbox" name="<?php echo RPX_VEMAIL_OPTION; ?>" value="true"<?php if (get_option(RPX_VEMAIL_OPTION) == 'true'){ echo ' checked="checked"'; } ?> />
      </td>
      <td class="rpx_td">&nbsp;</td>
    </tr>
    <tr id="rpx_comment_option" class="rpx_tr_lt rpx_tr_sub">
      <td class="rpx_td">
       <span  class="rpx_note"><label for="rpxcomm">Login link for comments:</label>
       <select id="rpxcomm" name="<?php echo RPX_COMMENT_OPTION; ?>">
         <option value="none"<?php if (get_option(RPX_COMMENT_OPTION) == 'none'){ echo ' selected="selected"'; } ?>>None</option><?php
    foreach($rpx_comment_actions as $key => $val){?>
         <option value="<?php echo $val; ?>"<?php if (get_option(RPX_COMMENT_OPTION) == $val){ echo ' selected="selected"'; } ?>><?php echo $key; ?></option><?php
    }?>
       </select></span>
       <span>*&nbsp;Wordpress&nbsp;3&nbsp;themes.<br />&sup1;&nbsp;For&nbsp;&quot;registered&nbsp;and&nbsp;logged&nbsp;in&nbsp;to&nbsp;comment&quot;</span>
      </td>
      <td class="rpx_td_left">&nbsp;</td>
    </tr>
    <tr class="rpx_tr_dk">
      <td class="rpx_td">
      <h3>Sign-In Regsistration</h3>
      Click <a href="?page=<?php echo RPX_MENU_SLUG; ?>&amp;rpx_cleanup=true">here</a> to remove Engage incomplete (no email) accounts older than <?php echo RPX_CLEANUP_AGE; ?> minutes old.
      </td>
      <td class="rpx_td">&nbsp;</td>
    </tr>
    <tr class="rpx_tr_dk rpx_tr_sub">
      <td class="rpx_td"><?php
    $rpx_reg_mesg = '';
    if (get_option('users_can_register') != 1){
      $rpx_reg_mesg = '(You must enable the Wordpress General Setting for Membership "<a href="./options-general.php#users_can_register">Anyone can register</a>".)';
    }
?>
      <label for="rpxautoreg">Enable automatic user registration <?php echo $rpx_reg_mesg; ?></label>
      <input id="rpxautoreg" type="checkbox" name="<?php echo RPX_AUTOREG_OPTION; ?>" value="true"<?php if (get_option(RPX_AUTOREG_OPTION) == 'true'){ echo ' checked="checked"'; } ?> />
      </td>
      <td class="rpx_td">&nbsp;</td>
    </tr>
    <?php
		$rpx_social_pub = get_option(RPX_SOCIAL_PUB);
    if ( !empty($rpx_social_pub) ){?>
    <tr class="rpx_tr_lt">
      <td class="rpx_td">
      <h3>Social Sharing Settings</h3>
      Setup Social Sharing widget <a target="_blank" href="<?php echo get_option(RPX_ADMIN_URL_OPTION); echo RPX_SOCIAL_SETUP_URL; ?>">here</a>.
      </td>
      <td class="rpx_td">&nbsp;</td>
    </tr>
    <tr class="rpx_tr_lt rpx_tr_sub">
      <td class="rpx_td">
      <label for="rpxsocial">Enable social sharing:</label>
      <input onclick="rpxshowhide('rpxsocial','rpx_share_option');rpxshowhide('rpxsocial','rpx_share_option2');" id="rpxsocial" type="checkbox" name="<?php echo RPX_SOCIAL_OPTION; ?>" value="true"<?php if (get_option(RPX_SOCIAL_OPTION) == 'true'){ echo ' checked="checked"'; } ?> />
      </td>
      <td class="rpx_td">&nbsp;</td>
    </tr>
    <tr id="rpx_share_option" class="rpx_tr_lt rpx_tr_sub">
      <td class="rpx_td">
       <label for="rpxsloc">Share link on articles:</label>
       <select id="rpxsloc" name="<?php echo RPX_S_LOC_OPTION; ?>">
         <option value="none"<?php if (get_option(RPX_S_LOC_OPTION) == 'none'){ echo ' selected="selected"'; } ?>>None</option>
         <option value="top"<?php if (get_option(RPX_S_LOC_OPTION) == 'top'){ echo ' selected="selected"'; } ?>>at opening of article</option>
         <option value="bottom"<?php if (get_option(RPX_S_LOC_OPTION) == 'bottom'){ echo ' selected="selected"'; } ?>>at closing of article</option>
       </select>&nbsp;
      </td>
      <td class="rpx_td">&nbsp;</td>
    </tr>
    <tr id="rpx_share_option2" class="rpx_tr_lt rpx_tr_sub">
      <td class="rpx_td">
      <label for="rpxsoccom">Share link on comments:</label>
      <input id="rpxsoccom" type="checkbox" name="<?php echo RPX_SOCIAL_COMMENT_OPTION; ?>" value="true"<?php if (get_option(RPX_SOCIAL_COMMENT_OPTION) == 'true'){ echo ' checked="checked"'; } ?> />&nbsp;
      </td>
      <td class="rpx_td">&nbsp;</td>
    </tr>
    <script type="text/javascript">rpxshowhide('rpxsocial','rpx_share_option');rpxshowhide('rpxsocial','rpx_share_option2');</script><?php
    }else{?>
    <tr class="rpx_tr_lt rpx_tr_sub">
      <td class="rpx_td">
      Visit your <a href="<?php echo get_option(RPX_ADMIN_URL_OPTION); echo RPX_SOCIAL_SETUP_URL; ?>" target="_blank">Social Widget Setup</a> if you would like to enable social sharing.<br />
      To update the plugin you must click Save after you are done.
      </td>
      <td class="rpx_td">&nbsp;</td>
    </tr><?php
    }
  }?>
  </table>  
  <p class="submit">
    <input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
  </p>
</form>
</div><?php
}

function rpx_message_box($message='') {
  if ( empty($message) ){
    global $rpx_messages;
    $messages = array();
    foreach ($rpx_messages as $key=>$msg){
      if ($msg['class'] == 'message'){
        $messages[] = $msg['message'];
      }
    }
    $message = '<p>'.implode('<br />', $messages).'</p>';
  }
  $rpxdir = get_option('siteurl') . '/wp-content/plugins/rpx/';
  $imgdir = $rpxdir.'images/';
?>
<div id="rpxmsgbox" class="rpxbox rpxmsgbox">
<div id="rpxmsgw1" class="rpxhoriz"></div>
<table id="rpxmsgw2" class="rpxvert"><tr id="rpxvrow" class="rpxvrow"><td id="rpxvcol" class="rpxvcol">
<span id="rpxmsgborder" class="rpxborder">
<span id="rpxmsgclose" class="rpxclose" onclick="hideRPX('rpxmsgbox')"><img src="<?php echo $imgdir; ?>close.png" alt="close" /></span>
<div id="rpxmsg" class="rpxmsg">
<div id="rpxmessage" class="rpxmessage"><?php echo $message; ?></div>
</div></span></td></tr></table></div>
<script type="text/javascript">
  showRPX('rpxmsgbox');
</script>
<?php
}

function rpx_register_form($collect='email') {
  global $rpx_http_vars;
  $rpxdir = get_option('siteurl') . '/wp-content/plugins/rpx/';
  $imgdir = $rpxdir.'images/';
  if ($rpx_http_vars['rpx_collect'] == 'username'){
    $collect = 'username';
  }
?>
<div id="rpxregbox" class="rpxbox rpxregbox" onload="showRPX('rpxregbox');">
<div id="rpxregw1" class="rpxhoriz"></div>
<table id="rpxregw2" class="rpxvert"><tr id="rpxvrow" class="rpxvrow"><td id="rpxvcol" class="rpxvcol">
<span id="rpxregborder" class="rpxborder">
<span id="rpxregclose" class="rpxclose" onclick="hideRPX('rpxregbox');"><img src="<?php echo $imgdir; ?>close.png" alt="close" /></span>
<div id="rpxregister" class="rpxregister">
<?php rpx_print_messages(); ?>
<form id="rpxregform" class="rpxregform" action="" method="get">
 <input type="hidden" name="action"       value="<?php echo RPX_REGISTER_FORM_ACTION ?>" />
 <input type="hidden" name="rpx_collect"  value="<?php echo urlencode($rpx_http_vars['rpx_collect']); ?>" />
 <input type="hidden" name="rpx_session"  value="<?php echo urlencode($rpx_http_vars['rpx_session']); ?>" />
 <input type="hidden" name="rpx_provider" value="<?php echo urlencode($rpx_http_vars['rpx_provider']); ?>" />
 <input type="hidden" name="redirect_to"  value="<?php echo urlencode($rpx_http_vars['redirect_to']); ?>" />
<?php
  if ($collect == 'email'){
    echo ' <input type="hidden" name="rpx_username" value="'.urlencode($rpx_http_vars['rpx_username']).'" />'."\n";
    echo ' <input type="text"   name="rpx_email"    value="" id="rpxemail" class="rpxemail" size="30" />';
  }elseif ($collect == 'username'){
    echo ' <input type="hidden" name="rpx_email"    value="'.urlencode($rpx_http_vars['rpx_email']).'" />'."\n";
    echo ' <input type="text"   name="rpx_username" value="" id="rpxusername" class="rpxusername" size="30" />';
  }else{
    echo ' <input type="hidden" name="rpx_username" value="'.urlencode($rpx_http_vars['rpx_username']).'" />'."\n";
    echo ' <input type="hidden" name="rpx_email"    value="'.urlencode($rpx_http_vars['rpx_email']).'" />'."\n";
    echo $collect;//$collect as html to ask for something else, maybe useful later
  }
?> <input id="rpxsubmit" class="rpxsubmit" type="submit" value="Submit" />
</form>
</div></span></td></tr></table></div>
<script type="text/javascript">
  showRPX('rpxregbox');
</script>
<?php
}

function rpx_open_widget(){
  global $rpx_http_vars;
  $add_parameters = '';  
  if( !empty($rpx_http_vars['rpx_username']) ){
    $add_parameters .= '&rpx_username='.urlencode($rpx_http_vars['rpx_username']);
  }
  $realm = get_option(RPX_REALM_OPTION);
  $siteurl = get_option('siteurl');
  if (stripos($siteurl, 'https:') === false){
    $realm_scheme = 'http';
  }else{
    $realm_scheme = 'https';
  }
  $rpx_token_url = RPX_TOKEN_URL.$add_parameters;
  $iframe_src = $realm_scheme.'://' . $realm . '/openid/embed?token_url=' . urlencode($rpx_token_url);
?>
<script type="text/javascript">
  document.getElementById('rpxiframe').src='<?php echo $iframe_src; ?>';
  showRPX('rpxlogin');
</script>
<?php
}

function rpx_wp_footer(){
  global $rpx_http_vars;
  if ($rpx_http_vars['action'] == RPX_REGISTER_FORM_ACTION){
    rpx_register_form();
  }
  $user_data = rpx_user_data();
  if ($user_data != false && !empty($user_data->rpx_provider) && did_action('show_user_profile') == false){
    return true;
  }
  $realm = get_option(RPX_REALM_OPTION);
  $siteurl = get_option('siteurl');
  if (stripos($siteurl, 'https:') === false){
    $realm_scheme = 'http';
  }else{
    $realm_scheme = 'https';
  }
  global $rpx_http_vars;
  $rpx_token_url = RPX_TOKEN_URL.'&redirect_to='.urlencode($rpx_http_vars['redirect_to']);
  $iframe_src = $realm_scheme.'://' . $realm . '/openid/embed?token_url=' . urlencode($rpx_token_url);
  $rpxdir = get_option('siteurl') . '/wp-content/plugins/rpx/';
  $imgdir = $rpxdir.'images/';
  ?>
<div id="rpxlogin" class="rpxbox">
<div id="fiftyfifty" class="rpxhoriz"></div>
<table id="rpxvertical" class="rpxvert"><tr id="rpxvrow" class="rpxvrow"><td id="rpxvcol" class="rpxvcol">
<span id="rpx_border" class="rpxborder">
<span id="rpx_close" class="rpxclose" onclick="hideRPX('rpxlogin')"><img src="<?php echo $imgdir; ?>close.png" alt="close" /></span>
<iframe id="rpxiframe" class="rpxiframe" scrolling="no" src="<?php echo $iframe_src; ?>"></iframe>
</span></td></tr></table></div><?php
}


function rpx_login_form() {
  global $rpx_http_vars;
  if (is_user_logged_in()){
    return;
  }
  if ($rpx_http_vars['action'] == 'register'){
    if (rpx_allow_register() === false){
      return;
    }
    $logreg = RPX_OR_REGISTER_PROMPT;
  }else{
    $logreg = RPX_OR_LOGIN_PROMPT;
  }
  rpx_print_messages();
  rpx_wp_footer();?>
<div class="rpx_label"><?php echo $logreg; ?></div><?php echo rpx_large_buttons();
}

function rpx_login_head() {
?>
<link rel='stylesheet' type='text/css' media='all' href='<?php echo WP_PLUGIN_URL.RPX_FILES_PATH; ?>stylesheet.css' /> 
<script type='text/javascript' src='<?php echo WP_PLUGIN_URL.RPX_FILES_PATH; ?>javascript.js'></script>
<?php
  rpx_inline_stylesheet();
}

function rpx_content_filter($content){
	$rpx_social_option = get_option(RPX_SOCIAL_OPTION);
	$rpx_social_pub = get_option(RPX_SOCIAL_PUB);
	$rpx_s_loc_option = get_option(RPX_S_LOC_OPTION);
	$in_the_loop = in_the_loop();
  if ($rpx_social_option != 'true' || empty($rpx_social_pub) || $rpx_s_loc_option == 'none' || $in_the_loop === false){
    return $content;
  }
  $rpx_social = rpx_social_share($content);
  if ($rpx_s_loc_option == 'top'){
    return $rpx_social.$content;
  }else{
    return $content.$rpx_social;
  }
}

function rpx_comment_filter($comment){
	$rpx_social_comment_option = get_option(RPX_SOCIAL_COMMENT_OPTION);
	$rpx_social_pub = get_option(RPX_SOCIAL_PUB);
	$in_the_loop = in_the_loop();
  if ($rpx_social_comment_option != 'true' || empty($rpx_social_pub) || $in_the_loop === false){
    return $comment;
  }
  $share = rpx_social_share($comment, true);
  return $comment.$share;
}

function rpx_user_provider_icon($author_name = NULL){
  if (in_the_loop() === false && $author_name != NULL){
    return $author_name;
  }
  global $rpx_providers;
  if ($author_name != NULL){
    $zero = 0;
    $comment = get_comment($zero);
    if (!empty($comment->user_id)){
      $user = get_userdata($comment->user_id);
    }
  }else{
    $user = rpx_user_data();
    $author_name = $user->user_login;
  }
  $icon = '';
  if (!empty($user->rpx_provider)){
    $provider = $user->rpx_provider;
    if ( !empty($provider) ){
      $provider = $rpx_providers["$provider"];
      $author = $user->user_login;
      $url = $user->user_url;
      $rpx_url = $user->rpx_url;
      if ( !empty($rpx_url) ){
        $url = $rpx_url;
      }
      $icon = '<div class="rpx_'.$provider.'_small rpx_icon_small rpxauthor" title="'.$author.'"></div>';
      if (  !empty($url) ){
        $icon = '<a href="'.$url.'" target="_blank">'.$icon.'</a>';
      }
    }
  }
  return $icon.$author_name;
}

function rpx_social_share($message, $comment=false){
  $posttitle   = rpx_js_escape(strip_tags(get_the_title()));
  $postlink    = rpx_js_escape(strip_tags(get_permalink()));
  $postsummary = rpx_js_escape(substr(strip_tags($message), 0, 46)).'...';
  $blogname    = rpx_js_escape(strip_tags(get_option('blogdescription')));
  $class = 'rpxsocial';
  $verb = 'Shared';
  $label = 'Share:';
  if ($comment === true){
    $postlink = rpx_js_escape(strip_tags(get_comment_link()));    
    $class = 'rpxsocial_small';
    $verb = 'Commented on';
    $label = 'Comment:';
  }
  $share  = '<div class="'.$class.' rpx_tooltip" onclick="rpxWPsocial(';
  $share .= "'".$label."','".$postsummary."','".$postlink."','".$posttitle."','".$verb." ".$posttitle."');";
  $share .= '"><span class="rpxsharebutton">share</span><div class="rpx_share_tip">Share this on:<br />'.rpx_social_icons().'</div></div>';
  return $share;
}

class RPX_Widget extends WP_Widget {
  function RPX_Widget() {
    $widget_options = array('classname' => 'rpx-widget', 'description' => 'Sign in with Janrain Engage.');
    $this->WP_Widget('janrain-engage-widget', RPX_WIDGET_TITLE, $widget_options);
  }
  function widget( $args, $instance ) {
    extract($args);
    $title = apply_filters( 'widget_title', empty($instance['title']) ? '' : $instance['title'], $instance, $this->id_base);
    echo $before_widget;
    if ( !empty( $title ) ) {
      echo $before_title . $title . $after_title;
    }
    $user_data = rpx_user_data();
    if ($user_data != false && !empty($user_data->rpx_provider) ){
      global $rpx_http_vars;
      $rpx_user_icon = rpx_user_provider_icon();
      echo $rpx_user_icon; 
?><br />
<a href="<?php echo wp_logout_url( $rpx_http_vars['redirect_to'] ); ?>" title="Logout">Log out</a>
<?php
    }elseif ($user_data != false && empty($user_data->rpx_provider) ){
      echo rpx_small_buttons(RPX_CONNECT_PROMPT);
    }else{
      echo rpx_small_buttons(RPX_LOGIN_PROMPT);
    }
    echo $after_widget;
  }
  function update( $new_instance, $old_instance ) {
    $instance = $old_instance;
    $instance['title'] = strip_tags($new_instance['title']);
    return $instance;
  }
  function form( $instance ) {
    $instance = wp_parse_args( (array) $instance, array( 'title' => '' ) );
    $title = strip_tags($instance['title']);
?>
<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label>
<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo esc_attr($title); ?>" /></p>
<?php
  }
}


function rpx_widget($args) {//deprecated
  extract($args);  
  echo $before_widget;
  echo $before_title.RPX_WIDGET_TITLE.$after_title;
  $user_data = rpx_user_data();
  if ($user_data != false && !empty($user_data->rpx_provider) ){
    global $rpx_http_vars;
    global $rpx_providers;
    $provider = $rpx_providers[$user_data->rpx_provider];
    $displayname = $user_data->display_name;
    $url = $user_data->user_url;
?>
Welcome <?php echo $displayname; ?><?php if ( !empty($provider) ){ ?><div class="rpx_<?php echo $provider; ?>_small rpx_icon_small rpxauthor" onclick="window.location.href='<?php echo $url; ?>'" title="<?php echo $displayname; ?>"></div><?php } ?><br />
<a href="<?php echo wp_logout_url( $rpx_http_vars['redirect_to'] ); ?>" title="Logout">Log out</a>
<?php
  }elseif ($user_data != false && empty($user_data->rpx_provider) ){
    echo rpx_small_buttons(RPX_CONNECT_PROMPT);
  }else{
    echo rpx_small_buttons(RPX_LOGIN_PROMPT);
  }
  echo $after_widget;
}

function rpx_small_buttons($label = ''){
  global $rpx_button_count;
  global $rpx_icon_override;
  global $rpx_providers;

  $providers = '';
  $rpx_provider_list = get_option(RPX_PROVIDERS_OPTION);
  if (is_array($rpx_provider_list)){
    $providers = array_flip(array_intersect($rpx_providers,$rpx_provider_list));
    $providers = array_slice($providers, 0, RPX_SMALL_ICONS_LIMIT);
  }

  if ($rpx_icon_override === true || empty($providers)){
    global $rpx_providers_small;
    $providers = $rpx_providers_small;
  }

  if ( !empty($label) ){
    $label = '<div class="rpx_label">'.$label.'</div>';
  }
  $rpx_buttons = '';
  foreach ($providers as $key => $val){
    $rpx_buttons .= '<div class="rpx_icon_small rpx_'.$key.'_small" title="'.htmlentities($val).'"></div>';
  }
  $buttons = '<div class="rpx_button" id="rpx_button_'.++$rpx_button_count.'"><div class="rpx_small_icons" id="rpx_small_icons_'.++$rpx_button_count.'" onclick="showRPX(\'rpxlogin\')">'.$rpx_buttons.'</div></div><div class="rpx_clear"></div>';
  return $label.$buttons;
}

function rpx_large_buttons($label = ''){
  global $rpx_button_count;
  global $rpx_icon_override;
  global $rpx_providers;

  $providers = '';
  $rpx_provider_list = get_option(RPX_PROVIDERS_OPTION);
  if (is_array($rpx_provider_list)){
    $providers = array_flip(array_intersect($rpx_providers,$rpx_provider_list));
    $providers = array_slice($providers, 0, RPX_LARGE_ICONS_LIMIT);
  }

  if ($rpx_icon_override === true || empty($providers)){
    global $rpx_providers_large;
    $providers = $rpx_providers_large;
  }

  if ( !empty($label) ){
    $label = '<div class="rpx_label">'.$label.'</div>';
  }
  $rpx_buttons = '';
  foreach ($providers as $key => $val){
    $rpx_buttons .= '<div class="rpx_icon_large rpx_'.$key.'_large" title="'.htmlentities($val).'"></div>';
  }
  $buttons = '<div class="rpx_button" id="rpx_button_'.++$rpx_button_count.'"><div class="rpx_large_icons" id="rpx_large_icons_'.++$rpx_button_count.'" onclick="showRPX(\'rpxlogin\')">'.$rpx_buttons.'</div></div><div class="rpx_clear"></div>';
  return $label.$buttons;
}

function rpx_edit_user_profile(){
  $user_data = rpx_user_data();
  if (!empty($user_data->rpx_provider)){
  $provider = htmlentities($user_data->rpx_provider);
?>
<h3>Currently connected to <?php echo $provider; ?></h3>
<?php
  }
  echo rpx_large_buttons('Connect to:');
}

function rpx_social_icons(){
  global $rpx_providers;
  $social_pub = get_option(RPX_SOCIAL_PUB);
  $social_providers = array_filter(explode(',',$social_pub));
  $rpx_social_icons = '';
  foreach ($social_providers as $key => $val){
    $rpx_social_icons .= '<div class="rpx_icon_small rpx_'.$val.'_small" title="'.htmlentities(array_search($val,$rpx_providers)).'"></div>';
  }
  $buttons = '<div class="rpx_social_icons">'.$rpx_social_icons.'</div>';
  return $buttons;
}

function rpx_comment_login() {
  global $rpx_http_vars;
  rpx_set_redirect();
  if (is_user_logged_in()){
    global $current_user;
    get_currentuserinfo();
    ?>
<div id="rpxwidget"><p>Welcome <?php echo $current_user->display_name; ?><br />
<a href="<?php echo wp_logout_url( $rpx_http_vars['redirect_to'] ); ?>" title="Logout">Log out</a></p></div>
<?php
  }else{
    $imgdir = get_option('siteurl') . '/wp-content/plugins/rpx/images/';
    ?>
<div id="rpxcomment"><?php echo rpx_small_buttons(RPX_COMMENT_PROMPT); ?></div><br />
<?php
  }
}


?>
